<?php

require_once("midi.php");

$fn=$argv[1] or die;
$out_fn=$argv[2] or die;
$f=file_get_contents($fn) or die;

$notes = array(
"C"  => 0,
"#C" => 1,
"D"  => 2,
"#D" => 3,
"E"  => 4,
"F"  => 5, "#E" => 5,
"#F" => 6,
"G"  => 7,
"#G" => 8,
"A"  => 9,
"#A" => 10,
"B"  => 11, "#B" => 11,
);

function getnum($f,&$p,$default){
	$v = $default;
	//if ($p<strlen($f)
	//$digit = $f[$p];
	$x = 0;
	while ($p<strlen($f) and ( ($digit = $f[$p]) != "" and $digit >= '0' and $digit <= '9' ) ) {
		$x*=10;
		$x+=(int)$digit;
		$v=$x;
		$p++;
		//if ($p>=strlen($f)) break;
		//$digit = $f[$p];
	}
	return $v;
}
$PPQN = 100;
function parse_music($f, &$track){
	$p=0;
	$settings = array(
		"=" => 64,
		"O" => 4,
		"V" => 13,
		"length" => 16,
		"T" => 100, // not really
		"Q" => 0,
		"@" => 128,
		"J" => 4,
		"K" => 64,
	);
	$defaults = array(
		"=" => 64,
	);
	while($p<strlen($f)){
		$command=getch($f,$p);
		switch($command) {
			case "$":
			case ")":
			case "=":
			case "@":
			case "H":
			case "I":
			case "J":
			case "K":
			case "L":
			case "M":
			case "N":
			case "O":
			case "P":
			case "Q":
			case "T":
			case "V":
				$n = getnum($f,$p,(int)@$defaults[$command]);
				printf("set %s = %d\r\n",$command,$n);
				$settings[$command] = $n;
			break;
			case "#":
				$command .= getch($f,$p);
			case "C":
			case "D":
			case "E":
			case "F":
			case "G":
			case "A":
			case "B":
			case "R":
				$n = getnum($f,$p,$settings["length"]);
				$settings["length"] = $n;
				printf("play note %s length %d\r\n",$command,$n);
				if ($command === "R") {
					$note = -1;
				} else {
					global $notes;
					$note = 60 + $notes[$command] + ($settings["O"] - 4) * 12;
				}
				$length = $settings["length"];
				printf("---> note = %d, length = %d\r\n", $note, $length);
				$fill = $settings["Q"];
				if (!$fill) $fill = 16;
				if($note>=0) $track->note_on($note);
				$note_length = round($length * ($fill/16));
				$track->delay($note_length);
				if($note>=0) $track->note_off($note);
				$track->delay($length - $note_length);
			break;
			case "[":
			case "&":
			case "]":
				printf("%s\r\n",$command);
			break;
			case "^":
				$settings["V"] = min($settings["V"]+1, 15);
				printf("inc volume = %d\r\n", $settings["V"]);
			break;
			case "_":
				$settings["V"] = max($settings["V"]-1, 0);
				printf("dec volume = %d\r\n", $settings["V"]);
			break;
			case "+":
				$settings["O"] = $settings["O"]+1 & 7;
				printf("inc octave = %d\r\n", $settings["O"]);
			break;
			case "-":
				$settings["O"] = $settings["O"]-1 & 7;
				printf("dec octave = %d\r\n", $settings["O"]);
			break;
			case "<":
				$settings["="] = 127;
			break;
			case ">":
				$settings["="] = 0;
			break;
			default:
				printf("Unknown command %s\r\n",$command);
				return;
			break;
		}
		switch ($command) {
			case "V":
			case "^":
			case "_":
				//static $volumes = array(0x00,0x03,0x07,0x0B,0x0F,0x13,0x18,0x1E,0x24,0x2B,0x34,0x3E,0x4C,0x60,0x7F);
				$track->controller(7 /*Volume*/, round($settings["V"]*0x7F/0x0F));
			break;
			case "@":
				global /*$sample_to_GM,*/ $instr_sample;
				$instr = $settings["@"];
				$sample = $instr_sample[$instr];
				//$GM = $sample_to_GM[$sample];
				//$track->program($GM);
				// Assuming custom SoundFont that matches the game:
				$track->program($sample);
				printf("Using custom instrument %d\r\n",$sample);
			break;
			case "[": // legato on
				$track->controller(68 /*Legato Pedal*/, 0x7F);
			break;
			case "]": // legato off
				$track->controller(68 /*Legato Pedal*/, 0x00);
			break;
			case "=":
			case "<":
			case ">":
				$track->controller(10 /*Pan*/, 0x7F - $settings["="]);
			break;
			case "T":
				// Sometimes it's set only at the beginning the last track, but it affects all tracks.
				// Wait... doesn't it work the same way in MIDI?
				// http://www.blitter.com/~russtopia/MIDI/~jglatt/tech/midifile/tempo.htm
				$tempo = $settings["T"];
				//global $PPQN;
				//$track->tempo(200 * $tempo * $PPQN);
				// It does(?), but not in all players...
				global $tempo_map;
				$tempo_map[$track->length] = $tempo;
			break;
		}
	}
	print("end\r\n\r\n");
	return $track->get_result();
}

function make_tempo_track($tempo_map) {
	global $PPQN;
	$track = new MIDI_Track();
	ksort($tempo_map);
	$last_time = 0;
	foreach($tempo_map as $time=>$tempo) {
		$track->delay($time - $last_time);
		$track->tempo(200 * $tempo * $PPQN);
		$last_time = $time;
	}
	$track->end();
	return $track->get_result();
}

$p=0;
$ln=getint2($f,$p);
$dt=getstr($f,$p,$ln);
$f=$dt;

$p=0;
$instr_addr=getint2($f,$p);

print "Instruments:\r\n";
$p=$instr_addr;
$instr_sample = array();
for($i=0;$p<strlen($f);$i++){
	$dt=getstr($f,$p,11);
	printf("@%2d: %s\r\n",$i,str2hex($dt));
	$instr_sample[] = ord($dt[0]);
}
print "\r\n";

/*
// Approximate each instrument sound sample of the game with a General Midi instrument.
// http://www.blitter.com/~russtopia/MIDI/~jglatt/tutr/gm.htm#Patch
// I identified each track by the key that toggles it in the ZSNES emulator. (F5..F12)
$sample_to_GM = array(
 0=>44-1, //deep violin? (menu track F8)
 1=>58-1, //trumpet (menu track F10,F11)
 2=>57-1, //sadder trumpet (menu track F10,F11)
 3=>61-1, //high-pitch, long sound (menu track F5,F6,F7,F9,F10,F11, level 1 track F7,F8,F10,F11,F12)
 4=>14-1, // tik (battle track F11)
 5=>106-1, // banjo? (level 1 track F6,F7,F10,F11)
 6=>0, // (sound 9 track F11/F12 end, sound 20 track F9)
 7=>27-1, // deep guitar (level 1 track F5, sound 20 track F9)
 8=>117-1, // drum (level 1 track F9)
 9=>117-1, // drum (level 1 track F9)
10=>117-1, // drum? (battle track F5)
11=>117-1, // drum? (battle track F5)
12=>0, // (boss intro track F12, end)
13=>0, //chirp (menu track F12, level 1 track F9) Tambourine, but that is a *drum* in MIDI and therefore can't have a pitch!
14=>0, // drum (boss intro track F12)
15=>59-1, // (sound 9 track F9)
16=>12-1, //jingle (Konami logo) one of CHROMATIC PERCUSSION
);
*/

$p=2;
$uk=getint1($f,$p);
//$tempo = NULL;
$tempo_map = array();

$MIDI_tracks = array();

for($i=0;$i<8;$i++){
	$q=getint2($f,$p);
	$MTrk = "";
	
	$track = new MIDI_Track($i);
	$track->channel = $i;
	//$track->tempo(200 * $tempo * $PPQN);
	$track->program(41-1);
	
	for($j=0;;$j++){
		$repeat=getint1($f,$q);
		printf("channel=%d index=%04X repeat=%02X",$i,$j,$repeat);
		if($repeat>=0xFE) break;
		$r=getint2($f,$q);
		$dt=getzstr($f,$r);
		printf(": %s\r\n",$dt);
		for($r=0;$r<$repeat;$r++) parse_music($dt, $track);
	}
	print "\r\n";
	$track->end();
	$MTrk = $track->get_result();
	
	printf("length of track = %d", $track->length);
	//if($i===1)
	$MIDI_tracks[] = $MTrk;
	print "\r\n";
	print "\r\n";
	//break;
}
print "\r\n";

// Tempo events must be on the first track for some MIDI players.
$MTrk = make_tempo_track($tempo_map);
array_unshift($MIDI_tracks, $MTrk); // must be first

// type 1 = multiple tracks starting at the same time
$MIDI = make_MIDI(1, $PPQN, $MIDI_tracks);

$fp=fopen($out_fn, "wb");
fwrite($fp,$MIDI);
fclose($fp);
