<?php

require_once("binary.php");

function tag($tag,$data){
	if(strlen($tag)!==4) die("Bad tag length!");
	return $tag.int42str(strlen($data)).$data;
}

function decode(&$f){
	$out="";
	$old=$older=0;
	for($p=0,$l=strlen($f);$p<$l;){
		$fl=getint1($f,$p);
		$shift = $fl>>4;
		$filter = ($fl>>2)&3;
		$loop = ($fl>>1)&1;
		$last = $fl&1;
		for($i=0;$i<8;$i++){
			$byte=getint1($f,$p);
			for($j=0;$j<2;$j++){
				$nibble=$j?$byte>>4:$byte&15;
				if($nibble&8) $nibble-=16;
				if($shift>=13) {
					//die("BAD shift? ".$shift." @ 0x".h2($p,4));
					$sample=($nibble>>3)<<12;
				}else{
					$sample=$nibble<<$shift;
				}
				// Filter
				switch($filter){
					case 0: $new = $sample; break;
					case 1: $new = $sample + $old*1 + ( -$old*1 >> 4); break;
					case 2: $new = $sample + $old*2 + ( -$old*3 >> 5) - $older + ($older*1 >> 4); break;
					case 3: $new = $sample + $old*2 + ( -$old*13 >> 6) - $older + ($older*3 >> 4); break;
					default: die("???");
				}
				// glitches...
				$out.=int22str($new);
				$older=$old; $old=$new;
			}
		}
		if($last){
			//if($p<$l) die("BAD last? @ 0x".h2($p,4)." len=0x".h2($l,4));
			break;
		}
	}
	return $out;
}

//$fn="outf2/0000";
$fn=$argv[1] or die("no arg?");
$f=file_get_contents($fn);
$p=0;
$n=getint1($f,$p);
mkdir("outsound_wav");
$q=1+$n*4;

$sr=8000; // ???

for($i=0;$i<$n;$i++){
	$l1=getint2($f,$p);
	$l2=getint2($f,$p);
	//printf("%2d: %d %d\r\n", $i, $l1, $l1+$l2);
	// Loop offset + total length
	printf("%2d: %4d %4d\r\n", $i, ($l1)/9*16, ($l1+$l2)/9*16);
	$dt=getstr($f,$q,$l1+$l2);
	$fp=fopen(sprintf("outsound_wav\\%04d",$i),"wb");
	fwrite($fp,$dt);
	fclose($fp);
	$dt=decode($dt);
	$fp=fopen(sprintf("outsound_wav\\%04d_dec",$i),"wb");
	fwrite($fp,$dt);
	fclose($fp);

	$fmt=
	int22str(1). // AudioFormat: 1=PCM
	int22str(1). // NumChannels: 1=Mono
	int42str($sr). // Samplerate
		  int42str($sr*2). // ByteRate = SampleRate * NumChannels * BitsPerSample/8
		  int22str(2). // BlockAlign = NumChannels * BitsPerSample/8
		  int22str(16). // BitsPerSample: 16
	"";
	$wav=tag("RIFF","WAVE".tag("fmt ",$fmt).tag("data",$dt));
	$fp=fopen(sprintf("outsound_wav\\%04d_dec.wav",$i),"wb");
	fwrite($fp,$wav);
	fclose($fp);
}
